<template>
  <form
    class="tab-pane"
    role="tabpanel"
    @submit.prevent="$emit('submit', controls)"
  >
    <div class="auth-modal-content">
      <div class="mb-3">
        <input
          v-model="controls.email"
          type="email"
          name="email"
          placeholder="Ваша почта"
          autocomplete="email"
        />
      </div>
      <div class="mb-3">
        <input
          v-model="controls.username"
          type="text"
          name="username"
          placeholder="Ваш логин"
          autocomplete="username"
        />
      </div>
      <div class="mb-3">
        <base-input
          v-model="controls.password"
          component="password"
          placeholder="Ваш пароль"
          autocomplete="new-password"
        />
      </div>
      <div class="mb-5">
        <base-input
          v-model="controls.retryPassword"
          component="password"
          placeholder="Повторите пароль"
          autocomplete="new-password"
        />
      </div>
      <div class="mb-3">
        <label for="policy2">
          <input
            id="policy2"
            v-model="controls.agreePolicy"
            type="checkbox"
            name="agree"
            required
          />
          <span>Согласен с <a href="#">политикой конфиденциальности</a></span>
        </label>
      </div>
      <button
        class="btn btn-primary w-100 d-block"
        type="submit"
        :disabled="loading || $v.controls.$invalid"
      >
        Зарегистрироваться
      </button>
    </div>
  </form>
</template>

<script>
import required from 'vuelidate/lib/validators/required'
import email from 'vuelidate/lib/validators/email'
import sameAs from 'vuelidate/lib/validators/sameAs'
import { mapState } from 'vuex'

const initialControls = () => {
  return {
    username: '',
    password: '',
    retryPassword: '',
    email: '',
    agreePolicy: false,
  }
}
export default {
  name: 'FormRegister',
  data() {
    return {
      controls: initialControls(),
    }
  },
  validations: {
    controls: {
      username: {
        required,
      },
      password: {
        required,
      },
      retryPassword: {
        required,
      },
      agreePolicy: {
        sameAs: sameAs(() => true),
      },
      email: {
        required,
        email,
      },
    },
  },
  computed: {
    ...mapState({
      loading: (state) => state.loading,
    }),
  },
  methods: {
    reset() {
      this.controls = initialControls()
    },
  },
}
</script>
